FN=120;

POST_DIAMETER_LOWER=7.5;
POST_DIAMETER_UPPER=5.5;
POST_HEIGHT_TOTAL=45;
POST_HEIGHT_LOWER=28;
BASE_WIDTH=12.5;
BASE_HEIGHT=3.5;
PIN_DIAMETER_UPPER=1.2;
PIN_DIAMETER_LOWER=2;
PIN_STEPPING_UPPER=4;
PIN_STEPPING_LOWER=6;

module post_cylinder(h,d) {
// base circle
linear_extrude(height=h)
    circle(d=d, $fn=FN);
}

module post_talus(blower,bupper,bh) {
// base reinforcement
polygon(points=[ 
    [0,0],
    [blower,0],
    [bupper,bh],
    [0,bh]
    ]);    
}

module post_hole(h,d) {
// mount screw hole    
linear_extrude(height=h)
    circle(d=d, $fn=FN);
}

module post_top(d) {
// rounded post top
sphere(d=d,$fn=FN);    
}


difference() { 
union() {
post_cylinder(POST_HEIGHT_LOWER, POST_DIAMETER_LOWER);
 translate([0,0,POST_HEIGHT_LOWER])
    rotate_extrude(angle=360,convexity=$FN)
        post_talus(BASE_WIDTH/2,POST_DIAMETER_UPPER/2,BASE_HEIGHT);
translate([0,0,POST_HEIGHT_LOWER+BASE_HEIGHT])  
    post_cylinder(POST_HEIGHT_TOTAL-POST_HEIGHT_LOWER-BASE_HEIGHT,POST_DIAMETER_UPPER);
translate([0,0,POST_HEIGHT_TOTAL])
    post_top(POST_DIAMETER_UPPER);
}    
    
for (i=[PIN_STEPPING_LOWER:PIN_STEPPING_LOWER:(POST_HEIGHT_LOWER/PIN_STEPPING_LOWER)*PIN_STEPPING_LOWER])
    translate([0,POST_DIAMETER_LOWER/2,i])
        rotate([90,0,0])
            linear_extrude(POST_DIAMETER_LOWER)
                circle(d=PIN_DIAMETER_LOWER,$fn=FN);

for (i=[POST_HEIGHT_LOWER+BASE_HEIGHT+PIN_DIAMETER_UPPER*2:PIN_STEPPING_UPPER:(POST_HEIGHT_TOTAL/PIN_STEPPING_UPPER)*PIN_STEPPING_UPPER])
    rotate([0,0,90])
    // un-comment the above "rotate" in order to get holes in the same plane
    translate([0,POST_DIAMETER_UPPER/2,i])
        rotate([90,0,0])
            linear_extrude(POST_DIAMETER_LOWER)
                circle(d=PIN_DIAMETER_UPPER,$fn=FN);


rotate([0,0,90])
// un-comment the above "rotate" to shave the "front" of the part (the one with holes)
translate([-POST_DIAMETER_LOWER/2,0,0])
// un-comment the above "translate" in order to "shave" the part for easier printing
linear_extrude(height=POST_HEIGHT_TOTAL) {
polygon(points=[ 
    [0,BASE_WIDTH/2],
    [-BASE_WIDTH/2,BASE_WIDTH/2],
    [-BASE_WIDTH/2,-BASE_WIDTH/2],
    [0,-BASE_WIDTH/2],   
    ]);  
}        
}    
